/*
 * Mathematische Verfahren
 * Medien- und Kommunikationsinformatik
 * Hochschule Reutlingen
 * 
 * Copyright (c) 2010 Oliver Schumann
 *
 * created: 		13.05.2010
 * last modified: 	09.06.2010
 */

import java.util.Hashtable;
import java.util.SortedMap;

public class Node implements Comparable<Node> {
  
	private String nodeName = "";
	private int count = 0;
	private Node node0 = null;
	private Node node1 = null;

	public Node(String s, int c) {
		this.nodeName = s;
		this.count = c;
	}

	public Node(Node n0, Node n1) {
		this.nodeName = n0.getNodeName() + n1.getNodeName();
		this.count = n0.getCount() + n1.getCount();
		this.node0 = n0;
		this.node1 = n1;
	}

	@Override
	public int compareTo(Node o) {
		return this.count - o.getCount();
	}

	public void getChilds(String bitStream,
			SortedMap<String, String> codeTable,
			SortedMap<String, String> deCodeTable)

	{
		if (hasChilds()) {
			this.node0.getChilds(bitStream + "0", codeTable, deCodeTable);
			this.node1.getChilds(bitStream + "1", codeTable, deCodeTable);
		} else {
			codeTable.put(nodeName, bitStream);
			deCodeTable.put(bitStream, nodeName);
		}
	}

	public boolean hasChilds() {
		return (node0 != null) && (node1 != null);
	}

	public String getNodeName() {
		return nodeName;
	}

	public int getCount() {
		return count;
	}

	public Node getNode0() {
		return node0;
	}

	public Node getNode1() {
		return node1;
	}
}
